<script lang="ts">
import { createNotifyAPI } from "src/apis/create-notify";

import { updateBillOrderAPI } from "src/apis/update-bill-order-status";

  import type { BillOrderModel } from "src/models/bill.order.type";

  let onShowDropdown = false;
  export let billData: BillOrderModel;

  const statusBillList = [
    "สร้างรายการ",
    "จัดเตรียมของ",
    "กำลังจัดส่ง",
    "ได้รับแล้ว",
    "ยกเลิก",
  ];

  const styleStatus: any = {
    [`สร้างรายการ`]: "bg-yellow-500 text-white",
    [`จัดเตรียมของ`]: "bg-blue-500 text-white",
    [`กำลังจัดส่ง`]: "bg-gray-500 text-white",
    [`ได้รับแล้ว`]: "bg-green-500 text-white",
    [`ยกเลิก`]: "bg-red-500 text-white"
  }

  function onClickDropDown() {
    onShowDropdown = true;
  }

  async function onSelectOption(status: string) {
    billData.statusOrder = status;
    setTimeout(() => {
      onShowDropdown = false;
    }, 200);
    await updateBillOrderAPI(billData);
    await createNotifyAPI(billData.userId, `รายการ ${billData.billId} มีการเปลี่ยนแปลงสถานะไปเป็น<br><span class="font-bold text-red-500 rounded">${status}</span>`)
  }

  function onOutFocus() {
    setTimeout(() => {
      onShowDropdown = false;
    }, 400);
  }
</script>


<div class="relative inline-block text-left border border-gray-300 rounded {styleStatus[billData.statusOrder]}">
  <div>
    <button
      on:blur={onOutFocus}
      on:click={onClickDropDown}
      type="button"
      class=" dark:bg-gray-800 shadow-sm flex items-center justify-center w-full rounded  px-4 py-2 text-sm font-medium text-white hover:bg-gray-900 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-offset-gray-100 focus:ring-gray-500"
      id="options-menu"
    >
      {billData.statusOrder}
      <svg
        width="20"
        height="20"
        fill="currentColor"
        viewBox="0 0 1792 1792"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          d="M1408 704q0 26-19 45l-448 448q-19 19-45 19t-45-19l-448-448q-19-19-19-45t19-45 45-19h896q26 0 45 19t19 45z"
        />
      </svg>
    </button>
  </div>
  {#if onShowDropdown}
    <div
      class="origin-top-right absolute right-0 mt-2 z-20 w-56 rounded-md shadow-lg bg-white dark:bg-gray-800 ring-1 ring-black ring-opacity-5"
    >
      <div
        class="py-1 "
        role="menu"
        aria-orientation="vertical"
        aria-labelledby="options-menu"
      >
        {#each statusBillList as status}
          <div
            on:click={() => onSelectOption(status)}
            class="cursor-pointer block px-4 py-2 text-md {styleStatus[status]} hover:bg-gray-900 hover:text-white dark:text-gray-100 dark:hover:text-white dark:hover:bg-gray-600"
            role="menuitem"
          >
            <span class="flex flex-col">
              <span> {status} </span>
            </span>
          </div>
        {/each}
      </div>
    </div>
  {/if}
</div>
